<template>
  <a-table
    ref="tableRef"
    :columns="showColumns"
    :data="data"
    :scroll="{ y: '100%', x: '100%' }"
  >
    <template #settingsTitle>
      <a-tooltip content="列设置" position="tr">
        <icon-settings
          class="settingBtn"
          @click="columnsSettingsVisible = true"
        />
      </a-tooltip>
    </template>
  </a-table>

  <x-colmuns-settings
    ref="columnsSettings"
    v-model:visible="columnsSettingsVisible"
    v-model:showColumns="showColumns"
    :init-colmuns="initColmuns"
    :table-ref="tableRef"
    @change-config="handleChangeConfig"
    @reset="handleReset"
  />
</template>

<script lang="ts" setup>
import { ref } from 'vue'
import { TableInstance } from '@arco-design/web-vue'

const handleChangeConfig = (v) => {
  console.log('JSON.stringify(v, null, 2)', v)
}

const columnsSettings = ref()

const initColmuns = ref([
  {
    title: 'Name',
    dataIndex: 'name'
  },
  {
    title: 'Salary',
    dataIndex: 'salary'
  },
  {
    title: 'Address',
    dataIndex: 'address'
  },
  {
    title: 'Email',
    dataIndex: 'email'
  },
  {
    title: 'Column1',
    dataIndex: 'Column1'
  },
  {
    title: 'Column2',
    dataIndex: 'Column2'
  },
  {
    title: 'Column3',
    dataIndex: 'Column3'
  },
  {
    title: 'Column4',
    dataIndex: 'Column4'
  },
  {
    title: 'Column5',
    dataIndex: 'Column5'
  },
  {
    title: 'Column6',
    dataIndex: 'Column6'
  },
  {
    title: 'Column7',
    dataIndex: 'Column7'
  },
  {
    title: 'Column8',
    dataIndex: 'Column8'
  },
  {
    title: 'Column9',
    dataIndex: 'Column9'
  },
  {
    title: 'Column10',
    dataIndex: 'Column10'
  }
])

const handleReset = () => {
  const config = {
    name: {
      hidden: false,
      sort: 0
    },
    salary: {
      hidden: true,
      sort: 1
    },
    address: {
      hidden: true,
      sort: 2
    },
    email: {
      hidden: true,
      sort: 3
    },
    Column1: {
      hidden: true,
      sort: 4
    },
    Column2: {
      hidden: true,
      sort: 5
    },
    Column3: {
      hidden: true,
      sort: 6
    },
    Column4: {
      hidden: true,
      sort: 7
    },
    Column5: {
      hidden: true,
      sort: 8
    },
    Column6: {
      hidden: true,
      sort: 9
    },
    Column7: {
      hidden: true,
      sort: 10
    },
    Column8: {
      hidden: true,
      sort: 11
    },
    Column9: {
      hidden: true,
      sort: 12
    },
    Column10: {
      hidden: true,
      sort: 13
    }
  }

  const columns = initColmuns.value

  columns.forEach((item) => {
    const { hidden, sort, fixed } = config[item.dataIndex]
    // @ts-ignore
    item.hidden = hidden
    // @ts-ignore
    item.sort = sort
    // @ts-ignore
    item.fixed = fixed
  })

  // @ts-ignore
  columns.sort((a, b) => a.sort - b.sort)

  initColmuns.value = columns

  columnsSettings.value.initData()
}

const data = ref([
  {
    key: '1',
    name: 'Jane Doe',
    salary: 23000,
    address: '32 Park Road, London',
    email: 'jane.doe@example.com',
    Column1: 'abcd-efg-higk',
    Column2: 'abcd-efg-higk',
    Column3: 'abcd-efg-higk',
    Column4: 'abcd-efg-higk',
    Column5: 'abcd-efg-higk',
    Column6: 'abcd-efg-higk',
    Column7: 'abcd-efg-higk',
    Column8: 'abcd-efg-higk',
    Column9: 'abcd-efg-higk',
    Column10: 'abcd-efg-higk'
  },
  {
    key: '2',
    name: 'Alisa Ross',
    salary: 25000,
    address: '35 Park Road, London',
    email: 'alisa.ross@example.com',
    Column1: 'abcd-efg-higk',
    Column2: 'abcd-efg-higk',
    Column3: 'abcd-efg-higk',
    Column4: 'abcd-efg-higk',
    Column5: 'abcd-efg-higk',
    Column6: 'abcd-efg-higk',
    Column7: 'abcd-efg-higk',
    Column8: 'abcd-efg-higk',
    Column9: 'abcd-efg-higk',
    Column10: 'abcd-efg-higk'
  },
  {
    key: '3',
    name: 'Kevin Sandra',
    salary: 22000,
    address: '31 Park Road, London',
    email: 'kevin.sandra@example.com',
    Column1: 'abcd-efg-higk',
    Column2: 'abcd-efg-higk',
    Column3: 'abcd-efg-higk',
    Column4: 'abcd-efg-higk',
    Column5: 'abcd-efg-higk',
    Column6: 'abcd-efg-higk',
    Column7: 'abcd-efg-higk',
    Column8: 'abcd-efg-higk',
    Column9: 'abcd-efg-higk',
    Column10: 'abcd-efg-higk'
  },
  {
    key: '4',
    name: 'Ed Hellen',
    salary: 17000,
    address: '42 Park Road, London',
    email: 'ed.hellen@example.com',
    Column1: 'abcd-efg-higk',
    Column2: 'abcd-efg-higk',
    Column3: 'abcd-efg-higk',
    Column4: 'abcd-efg-higk',
    Column5: 'abcd-efg-higk',
    Column6: 'abcd-efg-higk',
    Column7: 'abcd-efg-higk',
    Column8: 'abcd-efg-higk',
    Column9: 'abcd-efg-higk',
    Column10: 'abcd-efg-higk'
  },
  {
    key: '5',
    name: 'William Smith',
    salary: 27000,
    address: '62 Park Road, London',
    email: 'william.smith@example.com',
    Column1: 'abcd-efg-higk',
    Column2: 'abcd-efg-higk',
    Column3: 'abcd-efg-higk',
    Column4: 'abcd-efg-higk',
    Column5: 'abcd-efg-higk',
    Column6: 'abcd-efg-higk',
    Column7: 'abcd-efg-higk',
    Column8: 'abcd-efg-higk',
    Column9: 'abcd-efg-higk',
    Column10: 'abcd-efg-higk'
  }
])

const tableRef = ref<TableInstance>()
const showColumns = ref()
const columnsSettingsVisible = ref(false)
</script>

<style scoped lang="less"></style>
